from math import *
genv=globals().copy()

from casioplot import *
from DEQmessage import *

try:
  getkey
  is_cg100 = True
except:
  is_cg100 = False
  DEQMSG_NEXT = "[AC]"
  try:
    i = DEQMSG_VERSION.index(" v")
    DEQMSG_VERSION = DEQMSG_VERSION[:i+1] + DEQMSG_VERSION[i+2:]
  except: pass
  try:
    i = DEQMSG_EQ_REQ3.index(", just press")
    DEQMSG_EQ_REQ3 = DEQMSG_EQ_REQ3[:i] + "[EXE]"
  except: pass

set_pixel(0, 0, (0, 0, 255))
is_cg = get_pixel(0, 0)[2]

SCREEN_WIDTH = is_cg and 384 or 128
SCREEN_HEIGHT = is_cg and 192 or 64
GRAPH_OFFSET = is_cg and [4,2] or [0,0]
GRAPH_WIDTH = SCREEN_WIDTH - GRAPH_OFFSET[0]*2
GRAPH_HEIGHT = SCREEN_HEIGHT - GRAPH_OFFSET[1]*2

MAX_GRAPH = 3

KEY_OK = 24
KEY_EXE = 95
KEY_BACK = 22

CPLOT_SMALL = "small"
CPLOT_MEDIUM = "medium"

LABEL_S_W =8
LABEL_S_H =12
LABEL_M_W =10
LABEL_M_H =18-3
LABEL_L_W =18
LABEL_L_H =24-3

EQUATION = ""
MIN_X = None
MAX_X = None
MIN_Y = None
MAX_Y = None

ARROW = 0
EPS=None

# draw point
def draw_point(x_p, y_p, x_size, y_size, color):
    x_draw = ((x_p - x_size[0]) / (x_size[1] - x_size[0])) * GRAPH_WIDTH + GRAPH_OFFSET[0]
    y_draw = ((y_p - y_size[0]) / (y_size[1] - y_size[0])) * GRAPH_HEIGHT - GRAPH_OFFSET[1]

    if x_draw>SCREEN_WIDTH:
        return
    if y_draw < -SCREEN_HEIGHT:
        return

    for (a) in range (-1 , 2 , 1):
        for (b) in range (-1 , 2 , 1):
            set_pixel(int(x_draw + a), int (GRAPH_HEIGHT - y_draw + b), color)


# draw through point
def draw_through_point(x_p, y_p, x_size, y_size):
    x_draw = ((x_p - x_size[0]) / (x_size[1] - x_size[0])) * GRAPH_WIDTH + GRAPH_OFFSET[0]
    y_draw = ((y_p - y_size[0]) / (y_size[1] - y_size[0])) * GRAPH_HEIGHT - GRAPH_OFFSET[1]
    for (a) in range (-3 , 4 , 1):
        for (b) in range (-3 , 4 , 1):
            set_pixel(int(x_draw + a), int (GRAPH_HEIGHT - y_draw + b), (255,0,0))

# draw line
def Line(x1, y1, x2, y2, color):
    x_sub = x2 - x1
    y_sub = y2 - y1

    if (y_sub==0):
        step = 1 if (x1 < x2) else -1
        for x in range (x1, x2, step):
            set_pixel( x , y1, color)

    elif (x_sub==0):
        step = 1 if (y1 < y2) else -1
        for y in range (y1, y2, step):
            set_pixel( x1 , y, color)

    elif (abs(x_sub) >= abs(y_sub)):
        step = 1 if (x1 < x2) else -1
        tilt = y_sub / x_sub
        for x in range (0, x_sub, step):
            set_pixel( int(x + x1) , int(x * tilt + y1 ), color)
        
    else:
        step = 1 if (y1 < y2) else -1
        tilt =  x_sub / y_sub
        for y in range (0, y_sub, step):
            set_pixel( int(y * tilt + x1) , int (y + y1), color)

    set_pixel( x2 , y2, color)

# draw box
def Rectangle(x1, y1, x2, y2, color, paint):
    step = 1 if (y1 < y2) else -1
    for y in range (y1, y2+step, step):
        if paint or y == y1 or  y == y2:
           Line( x1, y, x2, y, color)
        else :
            set_pixel( x1, y, color)
            set_pixel( x2, y, color)


# draw line
def draw_line(x_p ,y_p, x_size, y_size, color):

    x_denomi = x_size[1] - x_size[0]
    y_denomi = y_size[1] - y_size[0]
    x_sub = x_p[1] - x_p[0]
    y_sub = y_p[1] - y_p[0]
    ratio = ( ( GRAPH_HEIGHT / y_denomi ) / (GRAPH_WIDTH / x_denomi) )

    if(x_sub == 0 and y_sub == 0):
        return

    if (abs(x_sub) >= abs(y_sub)* ratio):
        tilt = y_sub / x_sub * ratio
        limit = int((((x_p[1] - x_size[0]) / x_denomi) * GRAPH_WIDTH - ((x_p[0] - x_size[0]) / x_denomi) * GRAPH_WIDTH))
        if (limit >= 0):
            add = 1
        else:
            add = -1
        start = ((x_p[0] - x_size[0]) / x_denomi) * GRAPH_WIDTH + GRAPH_OFFSET[0]
        offset = ((y_p[0] - y_size[0]) / y_denomi) * GRAPH_HEIGHT + GRAPH_OFFSET[1]
        for i in range (0, limit, add):
            for (a) in range (is_cg and -1 or 0, is_cg and 2 or 1 , 1):
                for (b) in range (is_cg and -1 or 0 , is_cg and 2 or 1 , 1):
                    set_pixel(int(start + i + a) , int (GRAPH_HEIGHT - (offset + (i * tilt)) + b), color)
        
    else:
        tilt =  x_sub / y_sub / ratio
        limit = int((((y_p[1] - y_size[0]) / y_denomi) * GRAPH_HEIGHT - ((y_p[0] - y_size[0]) / y_denomi) * GRAPH_HEIGHT))
        if (limit >= 0):
            add = 1
        else:
            add = -1
        start = ((y_p[0] - y_size[0]) / y_denomi) * GRAPH_HEIGHT + GRAPH_OFFSET[1]
        offset = ((x_p[0] - x_size[0]) / x_denomi) * GRAPH_WIDTH  + GRAPH_OFFSET[0]

        for l in range (0, limit, add):
            for (a) in range (is_cg and -1 or 0, is_cg and 2 or 1 , 1):
                for (b) in range (is_cg and -1 or 0 , is_cg and 2 or 1 , 1):
                    set_pixel(int (offset + (l * tilt) + a) , int (GRAPH_HEIGHT - (start + l) + b), color)

#draw arrow
def draw_arrow( x_p, y_p, x_size, y_size, color, head):

    # base line
    draw_line( x_p, y_p, x_size, y_size, color )

    if(head):
        # arrow line
        x_denomi = x_size[1] - x_size[0]
        y_denomi = y_size[1] - y_size[0]
        dx = [int( (x_p[0] - x_size[0]) * GRAPH_WIDTH / x_denomi)  , int( (x_p[1] - x_size[0]) * GRAPH_WIDTH / x_denomi) ]
        dy = [int( (y_p[0] - y_size[0]) * GRAPH_HEIGHT / y_denomi)  , int( (y_p[1] - y_size[0]) * GRAPH_HEIGHT / y_denomi) ]

        angle = 30
        rad = atan2(dy[1]-dy[0] , (dx[1]-dx[0]) )
        rad_arrow = angle * pi / 180

        length = 6
        draw_line( [dx[1], (dx[1]-length*cos(rad+rad_arrow))], [dy[1], (dy[1]-length*sin(rad+rad_arrow))], [0,(GRAPH_WIDTH-1)], [0,(GRAPH_HEIGHT-1)], color )
        draw_line( [dx[1], (dx[1]-length*cos(rad-rad_arrow))], [dy[1], (dy[1]-length*sin(rad-rad_arrow))], [0,(GRAPH_WIDTH-1)], [0,(GRAPH_HEIGHT-1)], color )


# print title message
def print_message(lf):
    for i in range(0, 10, 1):
        print("")
    print (DEQMSG_VERSION)
    print (DEQMSG_DESCRIPTION)
    for i in range(0, lf, 1):
        print("")

# print message for input graph function
def print_graph_function(default):
    if default == ''  :
        print(DEQMSG_EQ_REQ1)
        if(DEQMSG_DEF_NONE != "") : print(DEQMSG_DEF_NONE)
    else:
        print(DEQMSG_EQ_REQ1)
        print(DEQMSG_EQ_REQ2 % default)
        print(DEQMSG_EQ_REQ3)

# input graph function
def get_graph_function(default):

    print_graph_function(default)

    input_string = ''
    while(input_string == ''):
        input_string = input(DEQMSG_EQ)
        if(input_string == '' and default != ''):
            input_string = default
            print("{}{}".format(DEQMSG_EQ, input_string))

    return input_string

def input_with_try(mess, default, def_string=None):
    ret=None
    input_string = input(mess)
    if(input_string == '' and default != None ):
        ret = default
        if(def_string==None): def_string=str(default)
        print("{}{}".format(mess,def_string))
        input_string=def_string
    try:
        check = eval(str(input_string))
        ret = float(check)
    except Exception as e:
        #print (e)
        print (DEQMSG_ERROR_VALUE)
    return ret

# print message for get graph size 
def print_graph_pos(target, default):
    print(DEQMSG_RANGE_REQ1 % target)
    if default != None:
        print(DEQMSG_RANGE_REQ2 % (target, default))
        print(DEQMSG_RANGE_REQ3)
    else:
        if(DEQMSG_DEF_NONE != "") : print(DEQMSG_DEF_NONE)

# get graph pos
def get_graph_pos(input_message, default, def_string=None):
    ret=default
    while True:
        ret = input_with_try(input_message, default, def_string)
        if ret != None:
            break
    return ret

# get graph size
def get_graph_size(x_size, y_size, x_param, y_param):

    while True:

        print_graph_pos(DEQMSG_RANGE_XMIN, x_param[0])
        x_size[0] = get_graph_pos(DEQMSG_RANGE_VALUE % DEQMSG_RANGE_XMIN, x_size[0], x_param[0])
        print_graph_pos(DEQMSG_RANGE_XMAX, x_param[1])
        x_size[1] = get_graph_pos(DEQMSG_RANGE_VALUE % DEQMSG_RANGE_XMAX, x_size[1], x_param[1])

        if x_size[1] > x_size[0]:
            break

        print(DEQMSG_ERROR_RANGE % (DEQMSG_RANGE_XMAX, DEQMSG_RANGE_XMIN))
        x_size[0] = None
        x_size[1] = None
        x_param[0] = None
        x_param[1] = None

    while True:
        print_graph_pos(DEQMSG_RANGE_YMIN, y_param[0])
        y_size[0] = get_graph_pos(DEQMSG_RANGE_VALUE % DEQMSG_RANGE_YMIN, y_size[0], y_param[0])
        print_graph_pos(DEQMSG_RANGE_YMAX, y_param[1])
        y_size[1] = get_graph_pos(DEQMSG_RANGE_VALUE % DEQMSG_RANGE_YMAX, y_size[1], y_param[1])
     
        if y_size[1] > y_size[0]:
            break

        print(DEQMSG_ERROR_RANGE % (DEQMSG_RANGE_YMAX, DEQMSG_RANGE_YMIN))
        y_size[0] = None
        y_size[1] = None
        y_param[0] = None
        y_param[1] = None

# get through point
def get_through_point(m, n, index, x_size, y_size):
    print(DEQMSG_POINT_REQ + str(index+1) + DEQMSG_POINT)
    #m
    while (True):
        m_temp = input_with_try(DEQMSG_EXPR_X, None)
        if( m_temp != None ):
            #m[index] = int(m_temp)
            m[index] = m_temp
            if ((m[index] >= x_size[0]) and (m[index] <= x_size[1])):
                break
            else:
                print(DEQMSG_ERROR_POINT)
    #n
    while(True):
        n_temp = input_with_try(DEQMSG_EXPR_Y, None)
        if( n_temp != None ):
            #n[index] = int(n_temp)
            n[index] = n_temp
            if ((n[index] >= y_size[0]) and (n[index] <= y_size[1])):
                break
            else:
                print(DEQMSG_ERROR_POINT)


def string_size(text, font_size):
    if(font_size==CPLOT_SMALL):
        cw=LABEL_S_W
        ch=LABEL_S_H
    elif(font_size==CPLOT_MEDIUM):
        cw=LABEL_M_W
        ch=LABEL_M_H
    else:
        cw = LABEL_L_W
        ch = LABEL_L_h

    text_len = len(text)

    return [cw*text_len,ch]

def draw_string_scr(x, y , text, color, font_size):

    size = string_size(text, font_size)

    if(x>=0 and y>=0):
        if(x+size[0] < SCREEN_WIDTH and (y+size[1] < SCREEN_HEIGHT)):
            draw_string(x , y, text, color, font_size)
            return True

    return False

def isOverlappedRect(rect1, rect2):
    if (max(rect1[0][0], rect2[0][0]) < min(rect1[1][0], rect2[1][0])) and (max(rect1[0][1], rect2[0][1]) < min(rect1[1][1], rect2[1][1])):
        return True
    else:
        return False

def draw_string_NonOverlapped0(x, y , text, color, font_size, rect0):

    if(rect0[0][0] != None):
        size = string_size(text, font_size)
        rect1 = [ [x, y], [x+size[0], y+size[1]] ]
        if(isOverlappedRect(rect0, rect1)):
            return False

    return draw_string_scr(x, y , text, color, font_size)


# draw axis
def draw_axis(x_size, y_size):
    dxw = GRAPH_WIDTH / (x_size[1] - x_size[0])
    dyh = GRAPH_HEIGHT / (y_size[1] - y_size[0])
    x_center = int(dxw * (0 - x_size[0]) + GRAPH_OFFSET[0])
    y_center = int(GRAPH_HEIGHT - (dyh * (0 - y_size[0]) - GRAPH_OFFSET[1]))
    x_label = ceil(x_size[0])
    y_label = floor(y_size[1])
    LABEL_W=8
    LABEL_H=12
    label0rect = [[None,None],[None,None]]
    
    label_len = [len(str(ceil(x_size[0]))), len(str(floor(x_size[1])))]
    max_len = max(label_len)

    start_X = abs(x_label - x_size[0])
    start_Y = abs(y_label - y_size[1])
    
    axis = True
    if(not is_cg or x_size[1] - x_size[0] > 25 or y_size[1] - y_size[0] > 13):
        #omit glid
        axis = False
    drawLabelX=is_cg and True
    if(dxw<LABEL_W*max_len):
        #omit X Label
        drawLabelX = False
    drawLabelY=is_cg and True
    if(dyh<LABEL_H):
        #omit Y Label
        drawLabelY = False
    
        
    for x in range(start_X, (x_size[1] - x_size[0]), 1):
        dotx=int(x*dxw + GRAPH_OFFSET[0])
        if(axis):
            Line(dotx, GRAPH_OFFSET[1], dotx, GRAPH_OFFSET[1]+GRAPH_HEIGHT-1,(0,255,255))
        Line(dotx, y_center-3, dotx, y_center-1, (0,0,0))
        if x_label != 0:
            if(drawLabelX):
                draw_string_scr(dotx - int(len(str(x_label))*LABEL_W/2) , y_center + GRAPH_OFFSET[1], str(x_label), (0,0,0), CPLOT_SMALL)
                    
        x_label = x_label + 1

    start_X_min = x_center - max_len*LABEL_W-2
    for y in range (start_Y, (y_size[1] - y_size[0]), 1):
        doty=int(y*dyh+ GRAPH_OFFSET[1])
        if(axis):
            Line( GRAPH_OFFSET[0], doty, GRAPH_OFFSET[0]+GRAPH_WIDTH-1, doty, (0,255,255))
        Line( x_center+1, int(y*dyh)+GRAPH_OFFSET[1], x_center+3,int(y*dyh)+GRAPH_OFFSET[1], (0,0,0))
        start_X = x_center - len(str(y_label))*LABEL_W-2

        if(is_cg and y_label==0):
            draw_0=draw_string_scr(x_center - 13 , doty + 1, str(y_label), (0,0,0), CPLOT_MEDIUM)
            if(draw_0):
                label0rect = [[x_center - 13,doty + 1],[x_center,doty + 16]]
        elif(drawLabelY):
            if(label0rect[1][1]==None or label0rect[1][1]<doty - 5):
                if(start_X_min>=0):
                    draw_string_scr(start_X , doty - 5, str(y_label), (0,0,0), CPLOT_SMALL)
        y_label = y_label - 1

    #omitted label
    if(is_cg and not drawLabelX):
        labelStart=str(ceil(x_size[0]))
        labelEnd=str(floor(x_size[1]))
        if(labelStart != '0'):
            draw_string_NonOverlapped0(0 , y_center + GRAPH_OFFSET[1], labelStart, (0,0,0), CPLOT_SMALL, label0rect)
        if(labelStart != '0'):
            draw_string_NonOverlapped0(GRAPH_WIDTH-len(labelEnd)*LABEL_W , y_center + GRAPH_OFFSET[1], labelEnd, (0,0,0), CPLOT_SMALL, label0rect)
    if(is_cg and not drawLabelY):
        labelStart=str(floor(y_size[1]))
        labelEnd=str(ceil(y_size[0]))
        start_X = x_center - len(str(labelStart))*LABEL_W-2
        draw_string_NonOverlapped0(start_X , 0, labelStart, (0,0,0), CPLOT_SMALL, label0rect)
        start_X = x_center - len(str(ceil(y_size[0])))*LABEL_W-2
        draw_string_NonOverlapped0(start_X , SCREEN_HEIGHT-LABEL_H-1, labelEnd, (0,0,0), CPLOT_SMALL, label0rect)

    # center line
    Line(GRAPH_OFFSET[0], y_center, GRAPH_OFFSET[0] + GRAPH_WIDTH-1, y_center, (0,0,0))
    Line(x_center, GRAPH_OFFSET[1], x_center, GRAPH_OFFSET[1] + GRAPH_HEIGHT-1, (0,0,0))

    if is_cg:
      draw_string_scr(SCREEN_WIDTH - 10 -1, y_center - 18, "x", (0,0,0), CPLOT_MEDIUM)
      draw_string_scr(x_center + 4 , 0, "y", (0,0,0), CPLOT_MEDIUM)

    show_screen()

# check include xy
def isIncXY(graph):
    ret = 0
    genv['x']=0
    genv['y']=0
    del genv['x']
    del genv['y']
    try:
        eval(graph, genv)
    except NameError:  #Contains x,y and all undefined symbols
        ret = 1

    return ret

# draw slope
def draw_slope(graph, x_size, y_size):
    a = (x_size[1] - x_size[0])
    b = (y_size[1] - y_size[0])

    ratio = ( (GRAPH_HEIGHT / b) / ( GRAPH_WIDTH / a ) )
      
    for c in range ((is_cg and 4 or 5)+GRAPH_OFFSET[0] , GRAPH_WIDTH , SCREEN_WIDTH // 16):
        for r in range ((SCREEN_HEIGHT // (8*2))+GRAPH_OFFSET[1], GRAPH_HEIGHT, (SCREEN_HEIGHT - GRAPH_OFFSET[1]) // 8):
            x = x_size[0] + (a * c / GRAPH_WIDTH)
            y = y_size[1] - (b * r / GRAPH_HEIGHT)
            genv['x']=x
            genv['y']=y
            try:
                s = eval(graph, genv) * ratio
                i = (is_cg and 6 or 3) / sqrt(1 + (s * s))
                j = i * b * s / GRAPH_HEIGHT
                i = i * a / GRAPH_WIDTH
                draw_arrow([x - i, x + i], [y - j, y + j], x_size, y_size, [0,255,0], ARROW )
                show_screen()
            except ValueError:
                pass
            except TypeError:
                pass

def eval_xy(graph, x, y):
    genv['x']=x
    genv['y']=y
    return eval(graph,genv)

def solve(graph, x, y, d):
  global EPS
  a = [0,1/5,3/10,3/5,1,7/8]

  b2 = [1/5]
  b3 = [3/40,9/40]
  b4 = [3/10,-9/10,6/5]
  b5 = [-11/54,5/2,-70/27,35/27]
  b6 = [1631/55296,175/512,575/13824,44275/110592,253/4096]

  c = [37/378,0,250/621,125/594,0,512/1771]
  dc = [2825/27648,0,18575/48384,13525/55296,277/14336,1/4]

  err_count = 0
  result = None
  yerr = 1
  TINY = 1e-30
  ERRCON=1.89e-4
  SAFETY=0.9
  PGROW=-0.2
  PSHRNK=-0.25
  ak= [0,0,0,0,0,0]
  ak[0]=eval_xy(graph, x, y)
  yscal=abs(y)+abs(d*ak[0])+TINY
  eps = 1/sqrt(SCREEN_WIDTH**2+SCREEN_HEIGHT**2) if(EPS==None) else EPS

  dn = d
  while(True):
    ak[1]=eval_xy(graph, x+a[1]*d, y+d*(b2[0]*ak[0]) )
    ak[2]=eval_xy(graph, x+a[2]*d, y+d*(b3[0]*ak[0]+b3[1]*ak[1]) )
    ak[3]=eval_xy(graph, x+a[3]*d, y+d*(b4[0]*ak[0]+b4[1]*ak[1]+b4[2]*ak[2]) )
    ak[4]=eval_xy(graph, x+a[4]*d, y+d*(b5[0]*ak[0]+b5[1]*ak[1]+b5[2]*ak[2]+b5[3]*ak[3]) )
    ak[5]=eval_xy(graph, x+a[5]*d, y+d*(b6[0]*ak[0]+b6[1]*ak[1]+b6[2]*ak[2]+b6[3]*ak[3]+b6[4]*ak[4]) )

    result = (c[0]*ak[0]+c[2]*ak[2]+c[3]*ak[4]+c[5]*ak[5])

    comp0 = (c[0]*ak[0])+(c[2]*ak[2])+(c[3]*ak[3])+(c[5]*ak[5])
    comp1 = (dc[0]*ak[0])+(dc[2]*ak[2])+(dc[3]*ak[3])+(dc[4]*ak[4])+(dc[5]*ak[5])
    diff = abs(comp0-comp1)

    yerr = abs(diff/yscal) / eps
    
    if(yerr>1):
      d1= d*0.9*(yerr**PSHRNK)
      d2= d*0.1
      d = max(d1,d2) if(d>=0) else min(d1,d2)
      if(x == x+d): return (None, 0, 0)
      
      err_count+=1
      if(err_count>10): return (None, 0, 0)

    else:
      if(yerr>ERRCON):
        #dn=SAFETY*d*(yerr**PGROW)
        dn=0
      else:
        dn=0
      break

  return (result, d, dn)

# draw graph
def draw_graph(graph, x_size, y_size, m, n, d, line_color):
    org_d = d
    for l in range (1 , -2, -2):
        d = org_d * l
        x = m
        y = n
        k = 180
        while(k > 0):
            try:
                s,d,dn = solve(graph, x, y, d)
                if(s==None): break
                y = y + s * d 
                x = x + d
                if x > x_size[1] or x < x_size[0]:
                    k = 0
                    break
                else:
                    if y > y_size[1] or y < y_size[0]:
                        k = 0
                        break
                draw_point(x, y, x_size, y_size, line_color)
                show_screen()
                d=org_d*l if(dn==0) else dn
            except ValueError:
                break
            except TypeError:
                break
            except Exception as e:
                raise e
            k = k - 1
            if x > x_size[1] or x < x_size[0]:
                k = 0
            else:
                if y > y_size[1] or y < y_size[0]:
                    k = 0

# getkey EXE/OK/#BACK
def wait_key():
  if is_cg100:
    while(True):
      if is_cg100:
        key = getkey()
        if key == KEY_OK :
          #OK
          return KEY_OK;
        if key == KEY_EXE :
          #EXE
          return KEY_EXE;
        #if key == KEY_BACK :
          #BACK
          #return KEY_BACK;
  else:
    try:
      while(True):
        pass
    except KeyboardInterrupt:
      return KEY_OK

# DiffEQ
def DiffEQ(graph, x_param, y_param, eps=None):
    global EPS

    EPS = eps
    SEQ_START = 0
    SEQ_EQ    = 1
    SEQ_VALUE = 2
    sequence = SEQ_START
    len_next_msg = len(DEQMSG_NEXT)
    medium_width = is_cg and 10 or 4
    medium_height = is_cg and 18 or 7
    dx = 0
    dy = 0
    x_size = [None,None]
    y_size = [None,None]
    
    if(x_param[0] != None and x_param[0] != ''): x_size[0] = eval(str(x_param[0]))
    if(x_param[1] != None and x_param[1] != ''): x_size[1] = eval(str(x_param[1]))
    if(y_param[0] != None and y_param[0] != ''): y_size[0] = eval(str(y_param[0]))
    if(y_param[1] != None and y_param[1] != ''): y_size[1] = eval(str(y_param[1]))

    # print title message
    lf=5 if(graph=='') else 3
    if not is_cg100: lf -= 2
    print_message(lf)

    sequence = SEQ_EQ

    while(True):

        if sequence == SEQ_EQ:
            clear_screen()
            # Input (x,y) that through special solution graph
            index = 0
            m = [None,None,None]    #x1,x2,x3
            n = [None,None,None]    #y1,y2,y3
            col = [[0,0,255], [255,0,255], [238,120,0]]    #MAX_GRAPH
          
            # input diff-eq function
            graph = get_graph_function(graph)
        
            # input view window
            get_graph_size(x_size, y_size, x_param, y_param)

            # Draw Axis
            draw_axis(x_size, y_size)

            # Draw Slope
            draw_slope(graph, x_size, y_size)

        if sequence == SEQ_VALUE:
            # Get through point(x,y)-> m,n
            get_through_point(m, n, index, x_size, y_size)
            if index < MAX_GRAPH-1:
                index += 1
            else:
                index = 0
        
            # Draw Slope
            clear_screen()
            draw_axis(x_size, y_size)
            draw_slope(graph, x_size, y_size)

            # Draw Graph
            d = 3 * (x_size[1] - x_size[0])/GRAPH_WIDTH
            i = 0
            for i in range(0,3):
                if m[i] != None and n[i] != None:
                    draw_graph(graph, x_size, y_size, m[i], n[i], d, col[i])
                    draw_through_point(m[i], n[i], x_size, y_size)
                    show_screen()

        # draw wait string
        dx = SCREEN_WIDTH - (len_next_msg+1) * medium_width -1
        dy = SCREEN_HEIGHT -1 -medium_height -4

        if is_cg:
          #Rectangle(dx, dy, dx + len_next_msg * medium_width, dy+medium_height, (255,255,255), True)
          draw_string(dx+1, dy+1, DEQMSG_NEXT, (255,255,255), CPLOT_MEDIUM)
          draw_string(dx, dy, DEQMSG_NEXT, (0,0,0), CPLOT_MEDIUM)
        show_screen()

        #wait OK/EXE/BACK
        key = wait_key()
        if key == KEY_BACK:
            sequence = SEQ_EQ
        else:
            sequence = SEQ_VALUE

#(C) 2024 CASIO COMPUTER CO., LTD.